//-------------------------------------------------------------------------------------------------------------------------------
{Loguje prubeh prace pluginu}
procedure LogWork(event: string);
var log : String;
begin
  EndForm_mem_Result.Lines.Add(FormatDateTime('hh":"nn":"ss',now) + ' ' + event);
  if SetForm_cb_Log_Enbl.Checked then begin
    if FileExists(MakroPath + 'Data\aDrakeSync.log') then begin
      log := FileToString(MakroPath + 'Data\aDrakeSync.log');
      if (Length(log) > 1048576) then Copy(log, 1, 1048576);  // omezeni logu na 1MB
      if (event = 'START') then log := log + CRLF;            // odradkovani logu
      log := log + CRLF + FormatDateTime('dd"."mm"."yyyy" "hh":"nn":"ss',now) + ' ' + event;
    end
    else log := FormatDateTime('dd"."mm"."yyyy" "hh":"nn":"ss',now) + ' ' + event;
    StringToFile(log, MakroPath + 'Data\aDrakeSync.log');
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{vyhazuje okno s chybou a sestreli aDrakeSync}
procedure ShowFatalMessage(txt: String);
begin
  LogWork(_('# Fatal: ') + ReplaceString(txt, CRLF, ', '));
  MessBox(txt + CRLF + CRLF + _('Plugin will break now...'),'aDrakeSync - Fatal Error',0);
  LogWork(_('# Forced END!'));
  GeoAbort;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{vyhazuje okno s chybou s moznosti sestrelit aDrakeSync}
procedure ShowErrorMessage(txt: String);
begin
  LogWork(_('# Error: ') + ReplaceString(txt, CRLF, ', '));
  if MessBox(_('# Error: ') + CRLF + txt + CRLF + CRLF + _('Continue plugin execution?'),'aDrakeSync - Error',4) = 7 then begin
    LogWork(_('# Forced END!'));
    GeoAbort;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{prevod jednoho Hex znaku na Int}
function HexToInt(HexValue: String): Integer;
begin
  case HexValue of
    '0'..'9': Result := StrToInt(HexValue);
    'a', 'A': Result := 10;
    'b', 'B': Result := 11;
    'c', 'C': Result := 12;
    'd', 'D': Result := 13;
    'e', 'E': Result := 14;
    'f', 'F': Result := 15;
    else Result := 0;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{prevod Hex na Dec}
function HexToDec(HexValue: String): Integer;
var i: Integer;
begin
  Result := 0;
  for i := 1 to Length(HexValue) do begin
    Result := Result + (HexToInt(copy(HexValue,i,1)) * Trunc(Power(16,Length(HexValue)-i)));
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{SQL Query - if table exists}
function SQLTableExists(db: TSqliteDatabase; table: string): Boolean;
begin
  Result := db.GetTableValue('SELECT count(*) FROM sqlite_master WHERE tbl_name = ''' + table + '''') > 0;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{SQL Query - tests version of database}
procedure SQLVersionTest(db: TSqliteDatabase; dbName: string);
begin
  if db.GetTableString('PRAGMA user_version') < SQL_Ver_Min then ShowFatalMessage(_('Required min. SQL database version = ') + SQL_Ver_Min + '('+ dbName +')');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Obsluha GeoBusy dialogu}
procedure GeoBusy;
begin
  GeoBusyStart;
  GeoBusyCaption(GB_Caption_Text);
  GeobusyKind(GB_Kind_Text);
  if GB_Progress_Value = 0 then GeoBusyValue(GB_Value_Text)
                           else GeoBusyProgress(GB_Progress_Value, GB_Progress_MaxValue);
end;
procedure GB_Caption(text: String);
begin
  if text <> '' then begin
    GB_Caption_Text := '* ' + text;
    LogWork('* ' + text);
  end
  else GB_Caption_Text := '';
  GeoBusy;
end;
procedure GB_Kind(text: String);
begin
  if text <> '' then begin
    GB_Kind_Text := '- ' + text;
    LogWork('- ' + text);
  end
  else GB_Kind_Text := '';
  GeoBusy;
  if MapForm.Visible then MapForm_lb_ProgressText.Caption := text;
end;
procedure GB_Value(text: String);
begin
  if text <> '' then begin
    GB_Value_Text := ' .. ' + text;
    LogWork(' .. ' + text);
  end
  else GB_Value_Text := '';
  GeoBusy;
end;
procedure GB_Progress(Level, Value, MaxValue : Integer);
  var cond : Boolean;
begin
  if (MaxValue <> 0) and (GB_Progress_MaxValue <> 0) then cond := Abs((Value*100/MaxValue) - (GB_Progress_Value*100/GB_Progress_MaxValue)) < 10;
  if not cond then begin
    MapForm_btn_Stop   .Enabled := (Value > 0);
    TrkForm_btn_Stop   .Enabled := (Value > 0);
    FnForm_btn_Stop    .Enabled := (Value > 0);
    MapMngForm_btn_Stop.Enabled := (Value > 0);
    if (MaxValue <> 0) then begin
      case Level of
        1:  begin
              MapForm_pb_ProgressBar1.Position := (Value * 100) / MaxValue;
              TrkForm_pb_ProgressBar1.Position := (Value * 100) / MaxValue;
              FnForm_pb_ProgressBar1.Position  := (Value * 100) / MaxValue;
            end;
        2:  begin
              MapForm_pb_ProgressBar2.Position := (Value * 100) / MaxValue;
              TrkForm_pb_ProgressBar2.Position := (Value * 100) / MaxValue;
              FnForm_pb_ProgressBar2 .Position := (Value * 100) / MaxValue;
            end;
      end;
    end;
    GB_Progress_Value    := Value;
    GB_Progress_MaxValue := MaxValue;
    GeoBusy;
  end;
end;
procedure GB_Clean;
begin
  GB_Caption_Text      := '';
  GB_Kind_Text         := '';
  GB_Value_Text        := '';
  GB_Progress_Value    := 0;
  GB_Progress_MaxValue := 0;
  MapForm_pb_ProgressBar1.Position := 0;
  TrkForm_pb_ProgressBar1.Position := 0;
  FnForm_pb_ProgressBar1 .Position := 0;
  MapForm_btn_Stop   .Enabled  := False;
  TrkForm_btn_Stop   .Enabled  := False;
  TrkForm_btn_Stop   .Enabled  := False;
  MapMngForm_btn_Stop.Enabled  := False;
  EventCancel := False;
  GeoBusy;
end;
function GB_Test : Boolean;
begin
  Result := GeoBusyTest or EventCancel;
  if Result then begin
    LogWork(_('- Canceled by user!'));
    GB_Clean;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - toolbar}
procedure form_ToolBar(Sender: TObject);
begin
  GeoSetToolbar(GEOGET_SCRIPTFULLNAME,SetForm_cb_ToolBar.Checked);
  GeoReloadPlugins;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Procedury formulare - update pluginu z webu}
procedure form_Update(Sender: TObject);
var msg : string;
begin
  GB_Clean;
  GB_Caption(_('Plugin update'));
  msg := GeoUpdatePackage(MakroPath + 'aDrakeSync.meta.ini');
  if msg <> '' then ShowMessage(msg);
  GeoReloadPlugins;
  GeoAbort ;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Vacuum na databazi}
procedure Vacuum(dbFulName:String);   // dbFulName = plna cesta k databazi
var
  db : TSqliteDatabase;
begin
  db := TSqliteDatabase.Create(dbFulName);
  try
    db.ExecSQL('Vacuum');
  finally
    db.free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{kontrola novych verzi ADS}
procedure CheckUpdate;
var cond   : boolean;
    script : String;
begin
  SetForm_cb_ToolBar     .Checked := GeoGetToolbar(MakroPath + 'aDrakeSync.ggp.pas');
  ADSForm_lbl_Current_ver.Caption := GeoGetPackageVersion(MakroPath + 'aDrakeSync.meta.ini');
  script := '';
  if SetForm_cb_AutoUpdate.Checked then begin
    LogWork(_('- ADS update checking...'));
    script := GeoGetPackageUpdateVersion(MakroPath + 'aDrakeSync.meta.ini');
  end;
  if script <> '' then ADSForm_lbl_Availbl_ver.Caption  := script
                  else ADSForm_lbl_Availbl_ver.Caption  := '?.?.?';
  LogWork(_('- aDrakeSync ') + ADSForm_lbl_Current_ver.Caption + _(' (available version: ') + ADSForm_lbl_Availbl_ver.Caption + ')');
  cond := CompareVer(ADSForm_lbl_Availbl_ver.Caption, ADSForm_lbl_Current_ver.Caption);
  ADSForm_lbl_Availbl.Enabled          := cond;
  ADSForm_lbl_Availbl_ver.Enabled      := cond;
  ADSForm_btn_Update.Enabled           := cond or not SetForm_cb_AutoUpdate.Checked;
  if cond then ADSForm_lbl_Availbl_ver.Font.Color := clRed
          else ADSForm_lbl_Availbl_ver.Font.Color := clWindowText;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{prednastaveni seznamu filtru do ComboBoxu}
procedure FillFilterList;
var id : TStringList;
    n  : Integer;
begin
  id := TStringList.Create;
  try
    FileList(GEOGET_DATADIR,id);
    for n := 0 to id.Count-1 do if RegexFind('[^\\]+\.ggf$',id[n]) then EndForm_cb_ShowList_ggfName.Items.Add(SeparateLeft(RegexExtract('[^\\]+\.ggf$',id[n]), '.ggf'));
  finally
    id.Free;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{nastavi seznam/vypis kesi - po ukonceni pluginu}
procedure ShowList;
begin
  GeoDBSelect(ADSForm_lbl_db_GG_Name.Caption);          // prepne na aktivni databazi
  GeoListClear;
  if EndForm_cb_ShowList_ggf.Checked  and EndForm_cb_ShowList_ggf.Enabled  then begin
    GeoFilterLoadFile(GEOGET_DATADIR + '\' + EndForm_cb_ShowList_ggfName.Text + '.ggf');
    GeoListLoad;
  end;
  if EndForm_cb_ShowList_Orig.Checked and EndForm_cb_ShowList_Orig.Enabled then GeoListFileAdd(MakroPath + 'Data\GeoList_Orig.ggt');
  if EndForm_cb_ShowList_Upd .Checked and EndForm_cb_ShowList_Upd .Enabled then GeoListFileAdd(MakroPath + 'Data\GeoList_Upd.ggt');
  if EndForm_cb_ShowList_Imp .Checked and EndForm_cb_ShowList_Imp .Enabled then GeoListFileAdd(MakroPath + 'Data\GeoList_Imp.ggt');
  if EndForm_cb_ShowList_FN  .Checked and EndForm_cb_ShowList_FN  .Enabled then GeoListFileAdd(MakroPath + 'Data\GeoList_FN.ggt');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Konvertuje Android cestu na cestu pouzitelnou v externim disku}
function ToCardPath(FileName: String): String;
begin
  if ADSForm_rb_CardReader.Checked then begin
     LogWork('  ToCardPath: CardPath = ' + CardPath + ' : FileName = ' + FileName + ' : AD_CardPath = ' + AD_CardPath);
     Result := CardPath + ReplaceString(FileName,AD_CardPath+'/','');              // nahradi cestu k Android SD karte
  end;
  if ADSForm_rb_MTP.Checked then begin
     LogWork('  ToCardPath: CardPath = ' + CardPath + ' : FileName = ' + FileName + ' : AD_CardPath = ' + AD_CardPath + ' : MTP_RootPath = ' + SetForm_ed_MTP_RootPath.Text);
     if (AD_DataPath = '') then begin
       Result := CardPath + SetForm_ed_MTP_RootPath.Text + FileName;
     end
     else begin
       Result := CardPath + ReplaceString(FileName,AD_CardPath,SetForm_ed_MTP_RootPath.Text);
     end;
  end;
  Result := ReplaceString(Result,'/','\');                                      // nahradi Android lomitka
  LogWork('  ToCardPath: Result = ' + Result);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Umoznuje v ceste pouziti konvence ".\" pro adresar skriptu, do budoucna pripadne dalsich chytrosti}
function SmartPath(path: String): String;
begin
  Result := ReplaceString(path, '.\', MakroPath);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Spusteni procesu}
procedure RunProc(cmd: String; file: String; ResultToFile: Boolean);
var script      : String;
    FileProc    : String;
    RegStr      : String;
    WriteToFile : String;
    HideCommand : String;
begin
  LogWork(' .. BatchFile: ' + file);
  FileProc :=  MakroPath + 'Data\' + file;
  if ResultToFile then begin
    WriteToFile := ' > ' + file + '.txt';
    HideCommand := '/WAIT /NOCONSOLE';
  end
  else begin
    WriteToFile := '';
    HideCommand := '/WAIT';
  end;
  StringToFile(AnsiToOEM(cmd), FileProc + '.bat');
  if FileExists(FileProc + '.txt') then DeleteFile(FileProc + '.txt');
  RunExec(MakroPath + 'hstart.exe ' + HideCommand + ' /D="' + MakroPath + 'Data\' + '" "cmd.exe /c "' + file + '.bat' +  WriteToFile + '""');  //RunExec(HideCommand + '"' + cmd + '"');
  if ResultToFile then begin
    if FileExists(FileProc + '.txt') then begin
      script := FileToString(FileProc + '.txt');
      Fetch(Script, CRLF); Fetch(Script, CRLF);  //vykousne kopii prikazove radky ulozenou v souboru
      StringToFile(Script, FileProc + '.txt');
      if Length(script) = 0 then begin
        ShowErrorMessage('BatchFile: ' + _('Batch failed!') + ' ' + _('File of result is empty!') +CRLF+
                       _('Try run this batch file from command line manualy and check errors in command window.') +CRLF+
                         FileProc + '.bat');
      end;
      RegStr := 'WARNING: Delay in loading RAPI';
      if RegexFind(RegStr, script) then begin
        ShowErrorMessage('BatchFile: ' + _('Connect timeout!') +CRLF+
                       _('Check your connection between device and PC.') +CRLF+CRLF+
                       _('Detail:') + CRLF + RegexExtract(RegStr + '.*' +CRLF+ '$', script));
      end;
      RegStr := '((ERROR|error)|Error)';
      if RegexFind(RegStr, script) then begin
        ShowErrorMessage('BatchFile: ' + _('Some errors in rapi process!') +CRLF+CRLF+
                       _('For more details check report file:') +CRLF+
                         MakroPath + 'Data\' + file + '.txt' +CRLF+CRLF+
                       _('Detail:') + CRLF + RegexExtract(RegStr + '.*' +CRLF+ '$', script));
      end;
    end
    else begin
      ShowErrorMessage('RapiUtils: ' + _('Batch failed!') + ' ' + _('File of result not found!') +CRLF+ MakroPath + 'Data\' + file + '.txt' +CRLF+CRLF+
                       _('Try run this batch file from command line manualy and check errors in command window.') +CRLF+
                         FileProc + '.bat');
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Vytvori adresar v PC}
procedure MakeDirPC(dir: String);
begin
  if not DirectoryExists(dir) then ForceDirectories(dir);  // Vytvori adresar, pokud neexistuje
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Hleda soubor v dadanem adresari (vcetne podslozek). vraci celou cestu k souboru}
function SearchFile(StartDir,Filename: String): String;
var
   Files,Queue : TStringList;
   n : Integer;
   q : String;
begin
  Result := _('File not found!');
  if not RegexFind('\$',StartDir) then StartDir := StartDir + '\';
  if DirectoryExists(StartDir) then
  begin
    Files := TStringList.Create;
    Queue := TStringList.Create;
    try
      Queue.Add(StartDir);
      while (Queue.Count > 0) do
      begin
        q := Queue[0];
        FileList(q,Files); Queue.Delete(0);
        for n := 0 to Files.Count-1 do
        begin
          if RegexFind('\\$',Files[n]) then
              Queue.Add(Files[n])
            else begin
              if ReplaceString(Files[n],q,'') = Filename then begin
                Result := Files[n];
                Break;
              end;
            end;
        end;
        if Result <> (_('File not found!')) then Break;
      end;
    finally
      Queue.Free;
      Files.Free;
    end;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{funkce pro ziskani hodnot ze staryho konfiguraku xxxxxxxx.config.pas (neco jako cteni z *.ini)}
function GetVariableValue(FilePath,Variable: String): String;
var
  ValuePos  :Integer;
  Value     :String;
begin
  if RegexFind('\.config.pas$',FilePath) then
  begin
    FilePath := Trim(FileToString(FilePath));
    {pozice hodnoty (k pozici promenne pricteme jeji delku a 4 znaky)}
    ValuePos := Pos(Variable,FilePath) + Length(Variable) + 4;
    {od zacatku hodnoty si vemem treba 20 znaku}
    Value := Copy(FilePath,ValuePos,20);
    {a ty od prvni uvozovky dal odkrojime}
    Value := Copy(FilePath,ValuePos,Pos('''',Value) - 1);
    Result := Value;
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{vytvoreni gjtemp.ini}
procedure MakeGeojarryIni(Task: String);
var
  GjIni :String;
begin
  try
    GjIni := '[geojarry]' + CRLF;
    GjIni := GjIni + 'username='   + GjUsername + CRLF;
    if Task <> 'destroy' then GjIni := GjIni + 'password=' + GjPassword + CRLF
                         else GjIni := GjIni + 'password=*******' + CRLF;
    GjIni := GjIni + 'proxyip='    + GEOGET_PROXYHOST + CRLF;
    GjIni := GjIni + 'proxyport='  + GEOGET_PROXYPORT + CRLF;
    GjIni := GjIni + 'proxyuser='  + GEOGET_PROXYUSER + CRLF;
    GjIni := GjIni + 'proxypass='  + GEOGET_PROXYPASS + CRLF;
    GjIni := GjIni + 'sessionfile=gjsession.txt' + CRLF;
    GjIni := GjIni + 'datadir=' + MakroPath + 'Data' + CRLF;
  finally
    StringTofile(GjIni, MakroPath + 'Data\gjtemp.ini');
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{popis chyby geojarryho}
function GeojarryError(id: Integer): String;
begin
  case id of
    3:   Result := _('GeoJarry error: File not found!');
    4:   Result := _('GeoJarry error: Bad file downloaded!');
    253: Result := _('GeoJarry error: Login on geocaching.com failed!');
    254: Result := _('GeoJarry error: Error in HTTP communication!');
    255: Result := _('GeoJarry: Storno by user!');
    else Result := _('GeoJarry common error!');
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{nahraje FieldNotes na gc.com a spusti je v prohlizeci}
procedure UploadOnGC;
var
  script : String;
  err    : Integer;
begin
  script := '"' + GeojarryExe + '" "' + MakroPath + 'Data\gjtemp.ini' + '" setform "' + MakroPath + 'FieldNotes_Upload.ini"';
  err := RunExec(script);
  case err of
    0: RunShell('http://www.geocaching.com/my/fieldnotes.aspx');
    else ShowErrorMessage(GeojarryError(err));
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{odstrani registr. udaje ze zalozniho souboru registru PDA}
procedure reg_PDA_CleanUp;
var
  str :String;
begin
  if FileExists(MakroPath + 'Data\reg_PDA_Option.txt') then begin
    str := FileToString(MakroPath + 'Data\reg_PDA_Option.txt');
    str := RegexReplace('"Password"="\S*\s*', str, '', False);
    str := RegexReplace('"Serial"="\S*\s*', str, '', False);
    StringToFile(str, MakroPath + 'Data\reg_PDA_Option.txt');
  end;
end;
//-------------------------------------------------------------------------------------------------------------------------------
{prenos souboru z PDA do PC, podpora FTP }
Function CopyPDAtoPC(PDA_File: String; PC_File: String): Boolean;
begin
  if ADSForm_rb_MTP.Checked then begin
     LogWork('  CopyPDAtoPC: PDA_File = ' + PDA_File);
     PDA_File:= ToCardPath(PDA_File);
  end;
  if ADSForm_rb_CardReader.Checked then PDA_File := ToCardPath(PDA_File);
  if ADSForm_rb_FTP       .Checked then PDA_File := ReplaceString(PDA_File, '\', '/');
  GB_Kind(_('copying: ') + PDA_File + ' -->> ' + PC_File);
  Result   := False;
  if ADSForm_rb_MTP.Checked then Result:= MtpGetFile(PDA_File,PC_File);
  if ADSForm_rb_CardReader.Checked then Result := CopyFile(PDA_File, PC_File);
  if ADSForm_rb_FTP       .Checked then Result := FtpGetFile(SetForm_ed_FTP_IP.Text, SetForm_ed_FTP_Port.Text, PDA_File, PC_File, SetForm_ed_FTP_User.Text, SetForm_ed_FTP_Pswd.Text);
  if Result then LogWork(_('- fille from PDA to PC transfered'))
            else ShowErrorMessage(_('Transfer of file failed!') + CRLF + CRLF + PDA_File + CRLF + '-->>' + CRLF + PC_File);
  GB_Kind('');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{prenos souboru z PC do PDA, podpora FTP }
Function CopyPCtoPDA(PC_File: String; PDA_File: String): Boolean;
begin
  if ADSForm_rb_MTP.Checked then PDA_File:= ToCardPath(PDA_File);
  if ADSForm_rb_CardReader.Checked then PDA_File := ToCardPath(PDA_File);
  if ADSForm_rb_FTP       .Checked then PDA_File := ReplaceString(PDA_File, '\', '/');
  GB_Kind(_('copying: ') + PC_File + ' -->> ' + PDA_File);
  Result := False;
  if ADSForm_rb_MTP.Checked then Result:= MtpPutFile(PC_File,PDA_File);
  if ADSForm_rb_CardReader.Checked then Result := CopyFile(PC_File, PDA_File);
  if ADSForm_rb_FTP       .Checked then Result := FtpPutFile(SetForm_ed_FTP_IP.Text, SetForm_ed_FTP_Port.Text, PDA_File, PC_File, SetForm_ed_FTP_User.Text, SetForm_ed_FTP_Pswd.Text);
  if Result then LogWork(_('- fille from PC to PDA transfered'))
            else ShowErrorMessage(_('Transfer of file failed!') + CRLF + CRLF + PC_File + CRLF + '-->>' + CRLF + PDA_File);
  GB_Kind('');
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Make a legal filename}
function SystemName(file: String): String;
begin
  Result := RegexReplace('\\|/|\*|\?|:|"|>|<|\|', file, '_', False);
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Float to formated String}
function FormateFloat(Value: Extended): String;
var str : string;
begin
  if Value < 100 then begin
    str := IntToStr(trunc(Value * 10));
    Insert('.', str, length(str));
    Result := str;
  end
  else Result := IntToStr(trunc(Value));
end;
//-------------------------------------------------------------------------------------------------------------------------------
{Create fix length string}
function FixLen(str: String; len: Integer): String;
var
  i : Integer;
begin
  if Length(str) > len then SetLength(str, len);
  for i := Length(str) to (len + 1) do begin
    str := str + TAB;
  end;
  Result := str;
end;
